#include "stdafx.h"
#include "Menu.h"
extern ablib::string tmp_string;
//HHOOK Menu::m_hook;

intptr_t Menu::AddRootMenu(const TCHAR *id, const TCHAR *str){
	if(!m_parent){
		::SetmacrodllLastError(_T("eEBhEw肳Ă܂D"));
		return FALSE;
	}
	if(::lstrcmp(id,_T("")) == 0){
		m_parent->GetMenu()->AddRootMenu(0,str);
		return TRUE;
	}else{
		if(m_str2int.find(id) != m_str2int.end()){
			::SetmacrodllLastError(ablib::string(_T("idF")) + id + _T(" ͊ɑ݂Ă܂D"));
			return FALSE;
		}
		m_parent->GetMenu()->AddRootMenu((int)m_int2str.size(),str);
		m_str2int[id] = m_int2str.size();
		m_int2str.push_back(id);
		return TRUE;
	}
}

intptr_t Menu::AddMenu(const TCHAR *parent, const TCHAR *id, const TCHAR *str){
	if(!m_parent){
		::SetmacrodllLastError(_T("eEBhEw肳Ă܂D"));
		return FALSE;
	}
	if(::lstrcmp(parent,_T("")) == 0)return AddRootMenu(id,str);
	if(m_str2int.find(parent) == m_str2int.end()){
		::SetmacrodllLastError(ablib::string(_T("idF")) + parent + _T(" ݂͑܂D"));
		return FALSE;
	}
	if(::lstrcmp(id,_T("")) == 0){
		m_parent->GetMenu()->AddMenu((int)m_str2int[parent],0,str);
		return TRUE;
	}else{
		if(m_str2int.find(id) != m_str2int.end()){
			::SetmacrodllLastError(ablib::string(_T("idF")) + id + _T(" ͊ɑ݂Ă܂D"));
			return FALSE;
		}
		m_parent->GetMenu()->AddMenu((int)m_str2int[parent],(int)m_int2str.size(),str);
		m_str2int[id] = m_int2str.size();
		m_int2str.push_back(id);
		return TRUE;
	}
}

intptr_t Menu::DeleteMenu(const TCHAR *id){
	if(!m_parent){
		::SetmacrodllLastError(_T("eEBhEw肳Ă܂D"));
		return FALSE;
	}
	if(m_str2int.find(id) == m_str2int.end()){
		::SetmacrodllLastError(ablib::string(_T("idF")) + id + _T(" ݂͑܂D"));
		return FALSE;
	}
	auto idnum = m_str2int[id];
	if(m_parent->GetMenu()->DeleteMenu((int)idnum)){
		m_int2str[idnum] = _T("");
		m_str2int.erase(id);
		return TRUE;
	}else return FALSE;
}


const TCHAR *Menu::CreatePopupMenu(intptr_t x, intptr_t y){
	if(!m_parent)return _T("");
	::ShowCursor(TRUE);
	POINT pt;pt.x = (LONG)x;pt.y = (LONG)y;::ScreenToClient(m_parent->GetHWND(),&pt);
//	m_hook = ::SetWindowsHookEx(WH_GETMESSAGE,sGetMsgProc,NULL,::GetCurrentThreadId());
//	::SetProp(m_parent->GetHWND(),_T("ABENORI_MACRODLL_MENU_PROP"),this);
	int r = m_parent->GetMenu()->CreatePopupMenu(ablib::window::Point(pt));
	if(!r)SetmacrodllLastError(ablib::window::GetLastError());
	tmp_string = m_int2str[r];
//	::RemoveProp(m_parent->GetHWND(),_T("ABENORI_MACRODLL_MENU_PROP"));
//	::UnhookWindowsHookEx(m_hook);
	::ShowCursor(FALSE);
	return tmp_string.c_str();

}

intptr_t Menu::Clear(){
	if(!m_parent)return FALSE;
	m_parent->GetMenu()->Clear();
	m_str2int.clear();
	m_str2int[_T("")] = 0;
	m_int2str.clear();
	m_int2str.push_back(_T(""));
	return TRUE;
}

/*
LRESULT Menu::sGetMsgProc(int code, WPARAM wParam, LPARAM lParam){
	Menu *me = reinterpret_cast<Menu*>(::GetProp(reinterpret_cast<MSG*>(lParam)->hwnd,_T("ABENORI_MACRODLL_MENU_PROP")));
	if(me)return me->GetMsgProc(code,wParam,lParam);
	else return ::CallNextHookEx(m_hook,code,wParam,lParam);
}

LRESULT Menu::GetMsgProc(int code, WPARAM wParam, LPARAM lParam){
	if(code < 0)return ::CallNextHookEx(m_hook,code,wParam,lParam);
	if(code == HC_ACTION){
		MSG *msg = reinterpret_cast<MSG*>(lParam);
		switch(msg->message){
		case WM_INITMENUPOPUP:
			::SendMessage(m_parent->GetHWND(),WM_MENUSELECT,MAKELONG(0,1),NULL);
			MessageBox(NULL,_T("test"),NULL,0);
			return FALSE;
		default:
			return ::CallNextHookEx(m_hook,code,wParam,lParam);
		}
	}else return ::CallNextHookEx(m_hook,code,wParam,lParam);
}

*/
