#ifndef __MONITOR_H__
#define __MONITOR_H__

#include <vector>

class Monitor{
public:
	Monitor(){}
	~Monitor(){}
	intptr_t GetMonitorFromPoint(intptr_t x, intptr_t y);
	intptr_t GetMonitorX(intptr_t handle);
	intptr_t GetMonitorY(intptr_t handle);
	intptr_t GetMonitorHeight(intptr_t handle);
	intptr_t GetMonitorWidth(intptr_t handle);


private:
	bool GetMonitorInfoByHandle(intptr_t handle,MONITORINFO *mi);
	std::vector<HMONITOR> m_hmonitor;

};

#endif //__MONITOR_H__

