#ifndef __PROCESS_H__
#define __PROCESS_H__

#include <system/Process.h>
#include <vector>

class Process{
public:
	Process(){};
	~Process();

	intptr_t Start(const TCHAR *arg,const TCHAR *wdir, intptr_t std, intptr_t stillalive);
	intptr_t WaitForExit(intptr_t handle);
	intptr_t WaitForInputIdle(intptr_t handle);
	const TCHAR *GetOutput(intptr_t handle){if(CheckHandle(handle))return m_process[handle-1]->out.c_str();else return _T("");}
	intptr_t HasExited(intptr_t handle){if(!CheckHandle(handle))return -1;else return m_process[handle-1]->process.HasExited()?TRUE:FALSE;}
	intptr_t Kill(intptr_t handle){if(!CheckHandle(handle))return FALSE;m_process[handle-1]->process.Kill();return TRUE;}

private:
	bool CheckHandle(intptr_t handle){
		if(handle <= 0 || handle > static_cast<int>(m_process.size())){
			SetmacrodllLastError(_T("LȒlł͂܂D"));
			return false;
		}else return true;
	}
	struct ProcessInfo{
		ablib::system::Process process;
		ablib::string out;
	};
	std::vector<ProcessInfo*> m_process;
};

#endif //__PROCESS_H__