#include "stdafx.h"
#include "Registory.h"
extern ablib::string tmp_string;

intptr_t Registory::ReadInt(const TCHAR *key,const TCHAR *subkey,const TCHAR *name){
	HKEY hkey;
	if(::lstrcmpi(key,_T("CLASSESROOT")) == 0)hkey = HKEY_CLASSES_ROOT;
	else if(::lstrcmpi(key,_T("CURRENTUSER")) == 0)hkey = HKEY_CURRENT_USER;
	else if(::lstrcmpi(key,_T("LOCALMACHINE")) == 0)hkey = HKEY_LOCAL_MACHINE;
	else if(::lstrcmpi(key,_T("USERS")) == 0)hkey = HKEY_USERS;
	else return 0;
	HKEY handle;
	if(::RegOpenKeyEx(hkey,subkey,0,KEY_QUERY_VALUE,&handle) != ERROR_SUCCESS)return 0;
	int rv;
	DWORD size = sizeof(rv);
	if(::RegQueryValueEx(handle,name,0,NULL,reinterpret_cast<BYTE*>(&rv),&size) != ERROR_SUCCESS)return 0;
	::RegCloseKey(handle);
	return (intptr_t)rv;
}

const TCHAR *Registory::ReadStr(const TCHAR *key,const TCHAR *subkey,const TCHAR *name){
	HKEY hkey;
	if(::lstrcmpi(key,_T("CLASSESROOT")) == 0)hkey = HKEY_CLASSES_ROOT;
	else if(::lstrcmpi(key,_T("CURRENTUSER")) == 0)hkey = HKEY_CURRENT_USER;
	else if(::lstrcmpi(key,_T("LOCALMACHINE")) == 0)hkey = HKEY_LOCAL_MACHINE;
	else if(::lstrcmpi(key,_T("USERS")) == 0)hkey = HKEY_USERS;
	else return _T("");
	HKEY handle;
	if(::RegOpenKeyEx(hkey,subkey,0,KEY_QUERY_VALUE,&handle) != ERROR_SUCCESS)return _T("");
	DWORD type,size;
	if(::RegQueryValueEx(handle,name,NULL,&type,NULL,&size) != ERROR_SUCCESS)return _T("");
	if(type != REG_SZ && type != REG_EXPAND_SZ)return _T("");
	TCHAR *s = new TCHAR[size + 1];++size;
	if(::RegQueryValueEx(handle,name,NULL,&type,reinterpret_cast<BYTE*>(s),&size) != ERROR_SUCCESS){
		delete[] s;
		::RegCloseKey(handle);
		return _T("");
	}
	tmp_string = s;
	delete[] s;
	::RegCloseKey(handle);
	return tmp_string.c_str();
}
