#ifndef __FILEOPEN_H__
#define __FILEOPEN_H__

#include <window/BaseModalDlg.h>
#include <window/SubClassWnd.h>

/**
t@CJA̕ςɎgBL[{[hSēB
l̎BWindowsȂ΃t@CJ_CAOgׂH
\[XEditƓ
*/

class FileOpen : public ablib::window::BaseModalDlg
{
public:
	FileOpen(void);
	~FileOpen(void){}
	const TCHAR *Create(HWND hwnd,TCHAR *defname,TCHAR *title,TCHAR *dir);

private:
	class EditProc : public ablib::window::SubClassDlg{
	public:
		const TCHAR *GetResult() const{return m_rv.c_str();}
		void ClearResult(){m_rv = _T("");}
		void SetDir(const TCHAR *dir){
			m_dir = dir;
			if(m_dir != _T("") && m_dir[m_dir.length() - 1] != '\\')m_dir += _T("\\");
		}
	private:
		bool OnChar(ablib::window::Dialog *wnd,TCHAR ch,intptr_t repeat);
		bool OnKey(ablib::window::Dialog *wnd,bool isDown,UINT vk,intptr_t repeat);
		INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam);
		
		ablib::string m_rv,m_dir;
		void Hokan();
		bool CtrlKey(TCHAR c);
		ablib::string GetCommonStr();
	}m_edit;

	ablib::string m_def,m_title;
	bool OnInitDialog(ablib::window::Dialog *wnd);

	NOCOPY(FileOpen);
};

#endif //__FILEOPEN_H__