#include "stdafx.h"
#include "Calc.h"
#include "Analyze.h"
#include "ListBox.h"
#include "FileOpen.h"
#include "Edit.h"
#include "File.h"
#include "Compile.h"
#include "TeXProject.h"
#include "ForString.h"
#include "Input.h"
#include "ISpell.h"
#include "CollectStr.h"
#include "Window.h"
#include "Menu.h"
#include "OLE.h"
#include "Hash.h"
#include "TextWindow.h"
#include "Process.h"
#include "Monitor.h"
#include "Env.h"
#include "PEG.h"

HINSTANCE g_dllint = NULL;

File		*g_File			= NULL;
ListBox		*g_ListBox		= NULL;
FileOpen	*g_FileOpen		= NULL;
Edit		*g_Edit			= NULL;
Compile		*g_Compile		= NULL;
Analyze		*g_Analyze		= NULL;
TeXProject	*g_TeXProject	= NULL;
String		*g_String		= NULL;
Input		*g_Input		= NULL;
CollectStr	*g_CollectStr	= NULL;
ISpell		*g_ISpell		= NULL;
Window		*g_Window		= NULL;
Menu		*g_Menu			= NULL;
OLE			*g_OLE			= NULL;
HashStrStr	*g_HashStrStr	= NULL;
HashStrInt	*g_HashStrInt	= NULL;
TextWindow	*g_TextWindow	= NULL;
Process		*g_Process		= NULL;
Monitor		*g_Monitor		= NULL;
Env			*g_Env			= NULL;
Calc        *g_Calc         = NULL;
PEG         *g_PEG          = NULL;

ablib::string tmp_string;

//n̈o
inline void Uninit(){
	delete g_File;
	delete g_ListBox;
	delete g_FileOpen;
	delete g_Edit;
	delete g_Compile;
	delete g_Analyze;
	delete g_TeXProject;
	delete g_String;
	delete g_Input;
	delete g_CollectStr;
	delete g_ISpell;
	delete g_Window;
	delete g_Menu;
	delete g_OLE;
	delete g_HashStrStr;
	delete g_HashStrInt;
	delete g_TextWindow;
	delete g_Process;
	delete g_Monitor;
	delete g_Env;
	delete g_Calc;
	delete g_PEG;
}

//Gg[|Cg(Ƃ񂾂H)
#ifdef __cplusplus
extern "C" 
#endif
BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD ul_reason_for_call, LPVOID pParam){
	switch (ul_reason_for_call) {
	case DLL_PROCESS_ATTACH:
		// CX^Xm
		g_dllint = hInstance;
#ifndef NDEBUG
//		::_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
#endif
//		HmJre::HmJreInit(hInstance);
//		MessageBox(NULL,_T("DLL[h܂B"),NULL,NULL);
		return TRUE;
	case DLL_PROCESS_DETACH:
		// n
		Uninit();
//		HmJre::HmJreUnInit();
//		MessageBox(NULL,_T("DLLA[h܂B"),NULL,NULL);
		return TRUE;
	default:
		break;
	}
	return TRUE;
}

ablib::string g_lasterror;

const TCHAR *GetmacrodllLastError(){return g_lasterror.c_str();}
void SetmacrodllLastError(const TCHAR *code){g_lasterror = code;}
void SetmacrodllLastError(const ablib::string &err){g_lasterror = err;}
void SetmacrodllLastError(DWORD code){
	TCHAR buf[4096];
	::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 0, code,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), buf, 4095, 0);
	g_lasterror = buf;
}

